/*********************************************************
				Voltage Calibration :
Rotation of <CONTROL> change value of requested voltage
Upper line displays :
1 = ADC for Potentometer
2 = ADC for output Volage measure
3 = Value of delta timing of pwm
Lower line
1 = entry of voltage read on multimeter, using rotary switch
	each push advance one digit, rotation change value
	validation with <ENTER>
2 = Voltage calculated, must be equal to value on multimeter.
return to menu by pushing <MENU>
>>>>>>>>>> REMARK 
The Voltage control do not use the same sheme than the other 
routines. It's  a polling method based on voltage dac measure.
<<<<<<<<<<<<<<<
**********************************************************/
void CalVolt (bit ms)
{
	uns24 calc24,cl;
	uns16 dat,calc;
	char MesVolt[4],i,pos;
	
//routine entry, init values and display
	upcntr = 0;
	OldMenu = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	TMR2ON = 1;
	TMR2IE = 0;
	ADCON0 = 1;
	LcdTmr  = 199;	
	writepos (' ',0,1);
	for (i=1;i!=16;i++) outdata(' ');
	writepos ('=',0,1);
	writepos ('V',6,1);
	for (i=0;i!=4;i++) MesVolt[i] = 0;
	pos = 0;
//continous loop until <MENU> pressed
	while (SW3 == 1)
	{
//control voltage with pwm		
		if (GO == 0)	
		{
			ScanAnalog();
			if (NextANP == 0) 
			CtlVolt (ANP0,0);
		}
		if (msflg)
		{
// update display every 200ms
			LcdTmr ++;
			if (LcdTmr == 200)
			{
				LcdTmr = 0;
				cvhexbcdN(ANP0);
				writepos (mil,0,0);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata (' ');
				cvhexbcdN(ANP1);
				writepos (mil,5,0);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata (' ');
				cvhexbcdN(PWMDuty);
				writepos (mil,10,0);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata (' ');
				i = MesVolt[0]+0x30;
				writepos (i,1,1);
				i = MesVolt[1]+0x30;
				outdata (i);
				outdata(',');
				i = MesVolt[2]+0x30;
				outdata (i);
				i = MesVolt[3]+0x30;
				outdata (i);
				calc24 =  (uns24)ANP1 * 1000;
				cl = calc24 / CoefVolt;
				dat = cl;
				cvhexbcdN(dat);
				writepos (mil,10,1);
				outdata (cent);
				outdata (',');
				outdata (dix);
				outdata (un);
			}
//	handle entry of voltage value		
			if (upcntr > 9)
			{
				upcntr = 9;
				dwncntr = 9;
			}	
			if(upcntr > 10)
			{
				upcntr = 0;
				dwncntr = 0;
			}	 	
			if (upcntr != OldMenu)
			{
				OldMenu = upcntr;
				MesVolt[pos] = upcntr;
			}
			if (msflg) msflg = 0;
			if (SELSW == 0)	//rotary sw advance one pos for chg value
			{
				tempo(10,1);
				while (SELSW == 0);
				tempo(10,1);
				pos++;
				if (pos >= 4) pos = 0;
			}
// if <enter> switch validate value 
			if (SW2 == 0)
			{
				tempo(10,1);
				while (SW2 == 0);
				tempo(10,1);
				dat = MesVolt[3];
				calc = (uns24)MesVolt[2]*10;
				dat += calc;
				calc = (uns24)MesVolt[1]*100;
				dat += calc;
				calc = (uns24)MesVolt[0]*1000;
				dat += calc;
				cl = (uns24)ANP1 * 1000;
				CoefVolt = cl / dat;
			}	
		}			
	}
// leave routine, stop pwm, update display and store coef in eeprom
	TMR2ON = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	MenuMode = 1;
	upcntr = 0;
	OldMenu = 1;
	FillBuffer(0,16);
	DisplayLine(0,16);
	writeprom (0,CoefVolt.high8);
	tempo(2,1);
	writeprom (1,CoefVolt.low8);
}

/*********************************************************
				Current Calibration :
Rotation of <CONTROL> change value of requested voltage
Upper line displays :
1 = Voltage in volt
2 = Potentiometre value
3 = PWM duty cyvle value
Lower line
1 = entry of current read on multimeter, using rotary switch
	each push advance one digit, rotation change value
	validation with <ENTER>
2 = current calculated, must be equal to value on multimeter.
return to menu by pushing <MENU>
>>>>>>>>>> REMARK 
The Voltage control do not use the same sheme than the other 
routines. It's  a polling method based on voltage dac measure.
<<<<<<<<<<<<<<<
**********************************************************/
void CalAmp (bit ms)
{
	uns24 calc24,cl;
	uns16 dat,calc;
	char MesVolt[4],i,pos;
	
//routine entry, init values and display
	upcntr = 0;
	OldMenu = 0;
	TMR2ON = 1;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	ADCON0 = 1;
	LcdTmr  = 199;	
	writepos (' ',0,1);
	for (i=1;i!=16;i++) outdata(' ');
	writepos ('=',0,1);
	writepos ('V',6,1);
	for (i=0;i!=4;i++) MesVolt[i] = 0;
	pos = 0;
//continous loop until <MENU> pressed
	while (SW3 == 1)
	{
//control voltage with pwm		
		if (GO == 0)	
		{
			ScanAnalog();
			if (NextANP == 0) 
			CtlVolt (ANP0,0);
		}
		if (msflg)
		{
// update display every 200ms
			LcdTmr ++;
			if (LcdTmr == 200)
			{
				LcdTmr = 0;
				calc24 =  (uns24)ANP1 * 1000;
				cl = calc24 / CoefVolt;
				dat = cl;
				cvhexbcdN(dat);
				writepos (mil,0,0);
				outdata (cent);
				outdata (',');
				outdata (dix);
				outdata (un);
				outdata (' '); 
				cvhexbcdN(ANP0);
				writepos (mil,6,0);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata (' ');
				cvhexbcdN(PWMDuty);
				writepos (mil,11,0);
				outdata (cent);
				outdata (dix);
				outdata (un);
				i = MesVolt[0]+0x30;
				writepos (i,1,1);
				i = MesVolt[1]+0x30;
				outdata (i);
				outdata(',');
				i = MesVolt[2]+0x30;
				outdata (i);
				i = MesVolt[3]+0x30;
				outdata (i);
				calc24 =  (uns24)ANP3 * 1000;
				cl = calc24 / CoefAmp;
				dat = cl;
				cvhexbcdN(dat);
				writepos (mil,10,1);
				outdata (cent);
				outdata (',');
				outdata (dix);
				outdata (un);
			}
//	handle entry of current value		
			if (upcntr > 9)
			{
				upcntr = 9;
				dwncntr = 9;
			}	
			if(upcntr > 10)
			{
				upcntr = 0;
				dwncntr = 0;
			}	 	
			if (upcntr != OldMenu)
			{
				OldMenu = upcntr;
				MesVolt[pos] = upcntr;
			}
			if (msflg) msflg = 0;
			if (SELSW == 0)	//rotary sw advance one pos for chg value
			{
				tempo(10,1);
				while (SELSW == 0);
				tempo(10,1);
				pos++;
				if (pos >= 4) pos = 0;
			}
// if <enter> switch validate value 
			if (SW2 == 0)
			{
				tempo(10,1);
				while (SW2 == 0);
				tempo(10,1);
				dat = MesVolt[3];
				calc = (uns24)MesVolt[2]*10;
				dat += calc;
				calc = (uns24)MesVolt[1]*100;
				dat += calc;
				calc = (uns24)MesVolt[0]*1000;
				dat += calc;
				cl = (uns24)ANP3 * 1000;
				CoefAmp = cl / dat;
			}	
		}			
	}
// leave routine, stop pwm, update display and store coef in eeprom
	TMR2ON = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;
	MenuMode = 1;
	upcntr = 0;
	OldMenu = 1;
	FillBuffer(0,16);
	DisplayLine(0,16);
	writeprom (2,CoefAmp.high8);
	tempo(2,1);
	writeprom (3,CoefAmp.low8);
}