//
#include "LCD.h"
/* ******************************************************* 
			L C D DISPLAY ROUTINES 
********************************************************* */


void construct (char val)

// **** assign pins of lcd to corresponding bits to pic port(s)
{
	LCD_D4 = val.0;
	LCD_D5 = val.1;
	LCD_D6 = val.2;
	LCD_D7 = val.3;
}

void outforce (char outf)
{
	LCD_ADR = 0;
	LCD_RW = 0;
	construct (outf);
	LCD_E = 1;
	nop();
	LCD_E = 0;
	tempo (15,1);
}

void checkbusy (void)
{
	bit svbusy;
	bit rs;

	rs = LCD_ADR;
// **hardware port change to input io pins as needed 
	TRISA |= 0xF0;
// **
	nop();
	LCD_E = 0;
	LCD_ADR = 0;
	svbusy = 1;
	LCD_RW = 1;
	nop();
	while (svbusy ==1)
	{
		LCD_E=1;
		nop();
		svbusy = PORTA.7;
		LCD_E=0;
		nop();
		LCD_E=1;
		nop();
		LCD_E=0;
		nop();
	}
	LCD_RW = 0;
// ** hrdw port change to output, pins as needed
	TRISA &= 0x0F;
// **
	LCD_ADR = rs;
}


void outdata (char snddata)
{
	char tmp;
		
	checkbusy();
		
	tmp = snddata & 0xF0;
	tmp = tmp / 16;
	construct(tmp);
	LCD_RW = 0;
	LCD_E = 1;
	nop();
	LCD_E = 0;
	tmp = snddata & 0x0F;
	construct(tmp);
	LCD_E = 1;
	nop();
	LCD_E = 0;
	LCD_RW = 1;


}

void writecmd (char outcmd)
{
	LCD_ADR = 0;
	outdata (outcmd);	
	LCD_ADR = 1;
}

void lcdinit (void) 
{
	LCD_E = 0;
	tempo (250,1);
	outforce (3);
	outforce (3);
	outforce (3);
	outforce (2);	// 4 bits interface
	writecmd (0b00101000);
	tempo (5,1);
	writecmd (0x0C);  // DISP ON, NO CURS, POS 0
	tempo (5,1);
	writecmd (0x06);  // curs incr, no shift display
	writecmd (0x80);  // ddram adr =0
}

 
void writepos (char outcar, char colonne, char ligne)
// here : 2 lines (0 and 1), 16 columns (0,15)

{char tmp;
	if (colonne > 15)	// depending on diplay x positions
		{colonne = 15;
		}
	if (ligne >1)		// depending on display y lines
		{ligne = 1;
		}
	tmp = colonne;
	if (ligne == 1)		// also adapt if more than 2 lines
		{
		tmp = tmp + 64;
		}
	tmp = tmp | 0x80;
	writecmd (tmp);	
	outdata (outcar);
}

 
void cleardisplay (void)
{
	writecmd (1);
	tempo(3,1);
}

/*
void curson (void)
{writecmd(0b01111);
}

void cursoff (void)
{writecmd(0b01100);
}
*/
/******************************************
	Write hex string
inp = char with value to be converted
out = hnibble is char to display as first char
	  lnibble to be displayed as 2nd char
**************************************************/
/*
void writehex (char hexval)
{
	lnibble = hexval & 0x0F;
	if (lnibble < 10) lnibble += 0x30;
	else lnibble += 0x37;
	hnibble = hexval / 16;
	if (hnibble > 10) hnibble += 0x30;
	else hnibble += 0x37;
}
*/
#ifdef Precision16
void cvhexbcdN (uns16 valcnv)
{
	uns16 tmpv;

	dmil = valcnv / 10000;
	tmpv = (long)dmil * 10000;
	valcnv = valcnv - tmpv;
	mil = valcnv / 1000;
	tmpv = (long)mil * 1000;
	valcnv = valcnv - tmpv;
	cent = valcnv / 100;
	tmpv = (long)cent * 100;
	valcnv = valcnv - tmpv;
	dix = valcnv / 10;
	tmpv = (long)dix * 10;
	un = valcnv - tmpv;
	dmil = dmil + 0x30;
	mil = mil + 0x30;
	cent = cent + 0x30;
	dix = dix + 0x30;
	un = un + 0x30;
}
#endif

#ifdef Precision24
void cvhexbcdL (uns24 valcnv)
{
	uns24 tmpv;
	
	million = valcnv / 1000000;
	tmpv = million * 1000000;
	valcnv = valcnv - tmpv;	
	cmil = valcnv / 100000;
	tmpv = (uns24)cmil * 100000;
	valcnv = valcnv - tmpv;
	dmil = valcnv / 10000;
	tmpv = (uns24)dmil * 10000;
	valcnv = valcnv - tmpv;
	mil = valcnv / 1000;
	tmpv = (uns24)mil * 1000;
	valcnv = valcnv - tmpv;
	cent = valcnv / 100;
	tmpv = (uns24)cent * 100;
	valcnv = valcnv - tmpv;
	dix = valcnv / 10;
	tmpv = (uns24)dix * 10;
	un = valcnv - tmpv;
	million = million + 0x30;
	cmil = cmil + 0x30;
	dmil = dmil + 0x30;
	mil = mil + 0x30;
	cent = cent + 0x30;
	dix = dix + 0x30;
	un = un + 0x30;
}
#endif

#ifdef Precision32
/* This part needs 32 bits compiler*/
void cvhexbcdXL (uns32 valcnv)
{
	uns32 tmpv;
	
	cmillion = valcnv / 100000000;
	tmpv = (uns32)cmillion * 100000000;
	valcnv = valcnv - tmpv;
	dmillion = valcnv / 10000000;
	tmpv = (uns32)dmillion * 10000000;
	valcnv = valcnv - tmpv;
	million = valcnv / 1000000;
	tmpv = (uns32)million * 1000000;
	valcnv = valcnv - tmpv;	
	cmil = valcnv / 100000;
	tmpv = (uns32)cmil * 100000;
	valcnv = valcnv - tmpv;
	dmil = valcnv / 10000;
	tmpv = (uns24)dmil * 10000;
	valcnv = valcnv - tmpv;
	mil = valcnv / 1000;
	tmpv = (uns24)mil * 1000;
	valcnv = valcnv - tmpv;
	cent = valcnv / 100;
	tmpv = (uns16)cent * 100;
	valcnv = valcnv - tmpv;
	dix = valcnv / 10;
	tmpv = (uns16)dix * 10;
	un = valcnv - tmpv;
	cmillion = cmillion + 0x30;
	dmillion = dmillion + 0x30;
	million = million + 0x30;
	cmil = cmil + 0x30;
	dmil = dmil + 0x30;
	mil = mil + 0x30;
	cent = cent + 0x30;
	dix = dix + 0x30;
	un = un + 0x30;
}
#endif
