/*************************************************
	Measure Speed
**************************************************/
void SetFinal (void)
{
	uns16 SvLimH,SvLimL;
	bit CtcOn;
	uns24 calc24;
	uns16 calc;
	
	OpsReady = 0;
	cleardisplay ();
	FillBuffer(30,16);
	DisplayLine(0,16);
	SvLimH = LimiteH;
	SvLimL = LimiteL;
	LimiteH = 800;
	LimiteL = 800;
	CtcOn = 0;
	TMR1H = 0;
	TMR1L = 0;
	TMR1IF = 0;
	TMR1IE = 1;		//int will clear TmrEndFg
	TMR1ON = 1;
	TMR2ON = 1;
	TMR2IE = 1;
	PWMDuty = 0;
	Tmr1EndFg = 0;

	while (SW3 == 1)
	{
		ScanAnalog();
		if (PORTC.7 == 0) 
		{
			Led = 1;
			if (CtcOn == 0)
			{
				PosContact = ANcalc;
				CtcOn = 1;
			}
		}		
		else 
		{
			Led = 0;
			if (CtcOn == 1) CtcOn = 0;
		}
		if (msflg)
		{
			LcdTmr ++;
			if (LcdTmr == 300)
			{
				LcdTmr = 0;
				calc24 = ModANP0 * 100;
				calc = (uns16)calc24 / 400;
				cvhexbcdN(calc);
				if (Dir) writepos ('+',0,1);
				else writepos ('-',0,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata ('%');
				outdata (' ');
				calc =  PosContact/3;
				cvhexbcdN(calc);
				writepos (mil,6,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata (' ');
				calc =  ANcalc/3;
				cvhexbcdN(calc);
				writepos (mil,12,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
			}	

			msflg = 0;
		}			
	}	
	Led = 0;
	LimiteH = SvLimH;
	LimiteL = SvLimL;
	TMR1ON = 0;
	TMR1IE = 0;
	TMR2ON = 0;
	TMR2IE = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;	
	MenuMode = 1;
	upcntr = 0;
	OldMenu = 1;
	FillBuffer(0,16);
	DisplayLine(0,16);
}

void SetInit(void)
{
	uns16 SvLimH,SvLimL;
	bit CtcOn;
	uns24 calc24;
	uns16 calc;
	
	OpsReady = 0;
	cleardisplay ();
	FillBuffer(31,16);
	DisplayLine(0,16);
	SvLimH = LimiteH;
	SvLimL = LimiteL;
	LimiteH = 800;
	LimiteL = 800;
	CtcOn = 0;
	TMR1H = 0;
	TMR1L = 0;
	TMR1IF = 0;
	TMR1IE = 1;		//int will clear TmrEndFg
	TMR1ON = 1;
	TMR2ON = 1;
	TMR2IE = 1;
	PWMDuty = 0;
	Tmr1EndFg = 0;
	
	while (SW3 == 1)
	{
		ScanAnalog();
		if (SW2 == 0) 
		{
			Led = 1;
			PosStart = ANcalc;
		}		
		else 
		{
			Led = 0;
		}
		if (msflg)
		{
			LcdTmr ++;
			if (LcdTmr == 300)
			{
				LcdTmr = 0;
				calc24 = ModANP0 * 100;
				calc = (uns16)calc24 / 400;
				cvhexbcdN(calc);
				if (Dir) writepos ('+',0,1);
				else writepos ('-',0,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata ('%');
				outdata (' ');
				calc =  PosStart/3;
				cvhexbcdN(calc);
				writepos (mil,6,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata (' ');
				calc =  ANcalc/3;
				cvhexbcdN(calc);
				writepos (mil,12,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
			}	

			msflg = 0;
		}			
	}	
	Led = 0;
	LimiteH = SvLimH;
	LimiteL = SvLimL;
	TMR1ON = 0;
	TMR1IE = 0;
	TMR2ON = 0;
	TMR2IE = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;	
	MenuMode = 1;
	upcntr = 0;
	OldMenu = 1;
	FillBuffer(0,16);
	DisplayLine(0,16);
}

void MesSpeed(void)
{
	uns16 RespTime;
	uns16 Move1Tmr;
	uns16 count,calc;
	uns32 average,calc32;
	char state;
	
	OpsReady = 0;
	count =0;
	average = 0;
	cleardisplay ();
	FillBuffer(32,16);
	DisplayLine(0,16);
	TimingMode = 1;
	RespTime = 0;
	Move1Tmr = 1500;
	state = 0;
	if (PosStart > PosContact) PosContact -= 200;
	else PosContact += 200;
	TMR1H = 0;
	TMR1L = 0;
	TMR1IF = 0;
	TMR1IE = 1;		//int will clear TmrEndFg
	TMR1ON = 1;
	TMR2ON = 1;
	TMR2IE = 1;
	PWMDuty = 0;
	while (SW3 == 1)
	{
		ScanAnalog();
//		if (NextANP == 1) 
//		{
//			CtlVolt (Volt,0);
//		}
		if (msflg)
		{
			if (state == 0)
			{
				ANcalc = PosStart;
				Move1Tmr++;
				if (Move1Tmr == 2000)
				{
					state = 1;
					Move1Tmr = 0;
					RespTime = 0;
				}
			}
			else if  (state == 1)
			{
				Led = 1;
				ANcalc = PosContact;
				if (PORTC.7 == 1)
				{
					RespTime++;
				}
				else 
				{
					state = 2;
				}		 
			}
			else if (state == 2)
			{
				Led = 0;
				average += RespTime;
				count++;
				Move1Tmr++;
				if (Move1Tmr == 1000) 
				{
					state = 0;
					Move1Tmr = 0;
				}	
			}			
			LcdTmr ++;
			if (LcdTmr == 300)
			{
				LcdTmr = 0;
				cvhexbcdN(RespTime);
				writepos (mil,0,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata ('m');
				outdata ('s');
				outdata (' ');
				calc32 =  average / count;
				calc = calc32;
				cvhexbcdN(calc);
				writepos (mil,7,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
				outdata ('m');
				outdata ('s');
				outdata (' ');
/*
				calc =  ANcalc;
				cvhexbcdN(calc);
				writepos (mil,12,1);
				outdata (cent);
				outdata (dix);
				outdata (un);
				*/
			}	

			msflg = 0;	
		}		
	}
	TMR1ON = 0;
	TMR1IE = 0;
	TMR2ON = 0;
	TMR2IE = 0;
	CCPR1L = 0;
	CCP1CON &= 0b11111100;		
	Led = 0;	
	TimingMode = 0;
	MenuMode = 1;
	upcntr = 0;
	OldMenu = 1;
	FillBuffer(0,16);
	DisplayLine(0,16);
}			