/**************************OPS***********/

#include "Calibrate.c"
#include "STest.c"
#include "VarParam.c"
#include "MeasureSpeed.c"

void Ops (bit ms)
{
	// dispatch tasks
	switch (OpsMode)
	{
		case 1:
		{
			Simpletest(ms);	//in STest.c
			break;
		}
		case 10:
		{
			SetVolt(ms);	//in VarParam.c
			break;
		}
		case 11:
		{
			SetDecal(ms);	//in Varparam.c
			break;
		}
		case 12:
		{
			SetLimites(ms);	//in VarParam.c
			break;
		}
		case 13:
		{
			ReInit(ms);		//in VarParam.c
			break;
		}
		case 20:
		{
			SetFinal();		//in MeasureSpeed.c
			break;
		}
		case 21:
		{
			SetInit();		//in MeasureSpeed.c
			break;
		}		
		case 22:
		{
			MesSpeed();		// in MeasureSpeed.c
			break;
		}
		case 40:
		{
			StartStop();	//in stest.c
			break;
		}								
		case 60:
		{
			CalVolt(ms);	//in Calibrate.c
			break;
		}	
		case 61:
		{
			CalAmp(ms);		//in Calibrate.c
			break;
		}
	 	default:
		{
			cleardisplay();
			FillBuffer(24,16);
			DisplayLine (0,16);
			FillBuffer(25,16);
			DisplayLine (1,16);
			while (SW3 == 1);
			Led = 0;	
			MenuInit();
			MenuMode = 1;
			
		}		
	}
	LcdTmr = 0;	
}