#define ResetVector 0x1000
#define Version "V:1.00 "
#define Date __DATE__
#define Hardware "HARD:V1 "

/************ PARAMETRES / DEFINITIONS ********/
#define CPUCLK					48		// 48 MHz
#define CYCLK					CPUCLK / 4	// Instruction cycle (only valid if cpu div by 4)	


#define TIMER0INPUT				CYCLK * 1000	// 12000 @48Mhz
#define BASETIMER0				65535 - TIMER0INPUT	// 12000ms is 48mhz clk div 4 
#define TIMER0H					BASETIMER0 /256
#define TIMER0L 				BASETIMER0 - (TIMER0H * 256)

#pragma rambank 1

/* HARDWARE DEF */
#define Led PORTC.1 
#define SW1 PORTB.7
#define SW3	PORTB.2
#define SW2 PORTC.6

//Pseudo analog ports
char NextANP,LocANP;
uns16 ANP0,ANP1,ANP2,ANP3;
bit ANPTogglle;

uns16 ADRes;

/* GLOBAL VARIABLE */
#pragma rambank -
uns16 ms;
char min, hour, sec;
bit msflg, secflg,Tmr1EndFg;
char CpyPB;
char RotaryDebounce;
bit timer1,Dir;
uns16 tempoms;
char flash;
uns16 ModANP0,ANcalc,ANcalc2,CPANP0,mest;
char TimingMode;
uns16 intdat;

#pragma rambank 1

bit MenuMode,OpsReady;
char OpsMode;
char OldMenu, MenuLevel,SelNbr;
char SubMenu1,SubMenu2;
char OutBuf [16];
uns16 LcdTmr;
bit flg,StartStp;
uns16 PWMDuty;
uns16 CoefVolt;		
//(ANP1 * CoefVolt)/1000 gives 1000 if 10.00 volts 
uns16 CoefAmp;
char ServoSeq;
uns16 Volt;
uns16 Corr;
bit CorDir;
uns16 Pos0;
uns16 LimiteH,LimiteL;
uns24 CpCalc;
uns16 PosContact,PosStart;

/* PROTOTYPES */

void High_Int (void);
void HandelRotary (void);
void HouseKeeping (bit ms);

#define CDATA_START 0xF00000
#pragma cdata[CDATA_START]
#pragma cdata[] = 0x4C04, 0x7406
#pragma cdata[0xF000B0]
#pragma cdata[] = "(c)Robert ","MULLER"," 2017 "
#pragma cdata[] = "SEVO CTRLR",0
#pragma cdata[] = Version
#pragma cdata[] = Date
#pragma cdata[] = Hardware
