//#utils

#include "Utils.h"

/*********************************************************
	General purpose tempo handeled by interrupt
	bit input if set means no return before time passed
*********************************************************/
void tempo (uns16 durationms,bit locked)		// max 65 sec but no validity check on param
{
	tempoms = durationms + 1; 
	timer1 = 1;
	if (locked)
	while (timer1);
} 

/**************** READ / WRITE EEPROM  ******************************
Readind / writing of the eeprom of pic.
reading :  
 input parameters : adress (byte) of byte to read
 output : read byte
writing :
 input parameters : adress (byte) of byte to write, value
*****************************************************/
char readprom (char eadr)
{
	char dato;
	
	GIE = 0;
	EECON1.2 = 0;
	EEADR = eadr;
	EEPGD = 0;
	CFGS = 0;
	RD = 1;
	dato =EEDATA;
	GIE =  1;
	return dato;
}

void writeprom (char eadr , char edata)
{

	EEADR = eadr;
	EEDATA = edata;
	EECON1.7 = 0;
	EECON1.6 = 0;
	EECON1.2 = 1;
	GIE = 0;
	EECON2 = 0x55;
	EECON2 = 0xAA;
	EECON1.1 = 1;
	while (EECON1.1 == 1);
	EECON1.2 = 0;
	GIE = 1;
}
/******************************************************
		ROTARY SWITCH UTILITY CODE

- InitRotary must be called by a main init procedure to 
  define the postion at power as 0. This routine may be called
  each time a start position is needed. 
- HandelRotary is to be called in a periodic mode by the main 
  loop, can also be updated by interrupt (int on change). 
  All variables are global to allow also a call from
  inside interrupt routine.
  upcntr and dwncntr are increased respectfully for each turn
  click clockwise and counter clockwise. 
- Remarck : upcntr and dwncntr can be char or uns16 as needed.
- This is a more general routine, comment/uncomment as needed,
	here downcounting is not used 	
*****************************************************/

void InitRotary (void)
{
	Roldsel = oldselB;
	Roldsel = Roldsel * 2;
	Roldsel += oldselA;
	upcntr = 0;
	dwncntr = 0;
}	
void HandelRotary (void)
{
	if (RotaryDebounce == 0)	//blind during debounce period
	{ 
		if (oldselA != SELA)
		{
			Rselchg = 1;
			oldselA = SELA;
			RotaryDebounce = 3; 	// 3 ms debounce
		}
		if (oldselB != SELB)
		{
			Rselchg = 1;
			oldselB = SELB;
			RotaryDebounce = 3;
		}
		if (oldselSW != SELSW)
		{
			RselSWchg = 1;
			oldselSW = SELSW;
			RotaryDebounce = 10;
		}
	}
	if (Rselchg != 0)
	{
		Rselchg = 0;
		newsel = oldselB;
		newsel = newsel * 2;
		newsel = newsel + oldselA ;	
				
		switch (Roldsel)
		{
			case (0b00):
			{
				if (newsel == 0b01) if (upcntr != 0) upcntr --;
				if (newsel == 0b10) if (upcntr < 101) upcntr++;
				break;
			}
			case (0b01):
			{
				//if (newsel == 0b00) upcntr++;
				//if (newsel == 0b11) dwncntr ++;
				break;
			}	
		 	case (0b10):
		 	{
			 	//if (newsel == 0b11) upcntr++;
				//if (newsel == 0b00) dwncntr ++;
			 	break;
			}
			case (0b11):
			{
				//if (newsel == 0b10) dwncntr++;
				//if (newsel == 0b01) upcntr++;
				break;
			}
		}
		Roldsel = newsel;
	}
}

/******************** SCAN ANALOG PORTS ****************
 scan in raw each 6 analog ports and return a value between 
 0 and 1023 in corresponding variables,ANP0, ANP1 ... 
 actual measure is done by an interrupt rtg
********************************************************/
 
// start conversion
void ScanAnalog (void)
{
	char i;

	while (GO != 0);
	
	LocANP++;
	if (LocANP == 8) LocANP = 0;
	if (LocANP.0 == 1) NextANP = 1;
	else NextANP = LocANP / 2;
	i = NextANP * 4;
	i = i|1;
	ADCON0 = i;		
	GO = 1;	// start conversion
}
	

/******************************************************
	Adjust voltage to requested dac value.
	correct CCP duty cycle accordingly 
	must be called as much as possible to increase voltage stability
********************************************************/

void CtlVolt (uns16 VDac,bit StartFg)
{
	char i;
	uns16 dat,calc;
	
	while (TMR2IF != 1)
	{
//		ADCON0 = 7;
//		NextANP = 1;
//		while (GO != 0);
	}
	{
		TMR2IF = 0;
		if (ANP1 < VDac)	//must increase
		{
			calc = VDac - ANP1;
			PWMDuty = calc;
			if (PWMDuty > 1023) PWMDuty = 1023;
		}
		if (ANP1 > VDac)	//must decrease
		{
			calc = (ANP1 - VDac);
			if (PWMDuty > 0) PWMDuty --;
		}
/*
		if (ANP1 < VDac)	//must increase
		{
			calc = VDac - ANP1;
			if (PWMDuty < 1023) PWMDuty++;
	
		}
		if (ANP1 > VDac)	//must decrease
		{
			calc = (ANP1 - VDac);
			if (PWMDuty > 0) PWMDuty --;
		}
*/
		dat = PWMDuty/4;
		CCPR1L = dat.low8;
		CCP1CON.4 = PWMDuty.0;
		CCP1CON.5 = PWMDuty.1;
	}		
}
